/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2008 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: hamilton.h,v 1.7 2008/03/14 02:05:34 liuhui Exp $ */
#ifndef PHG_HAMILTON_H

#ifdef __cplusplus
extern "C" {
#endif

/* initial order */
/* 0: success, or fail */
INT phgGridInitOrder(GRID *g, BOOLEAN dist);

/* *******************************************
 * construct Hamiltonian Path
 * success: 0, or fail
 * serial version
 * ******************************************/
INT phgHamiltonPath(GRID *g);

#ifdef __cplusplus
}
#endif

#define PHG_HAMILTON_H
#endif
